# Source Generated with Decompyle++
# File: in.pyc (Python 2.3)

'''TestCases for checking that it does not segfault when a DBEnv object
is closed before its DB objects.
'''
import os
import sys
import tempfile
import glob
import unittest

try:
    from bsddb import db
except ImportError:
    from bsddb3 import db

from test_all import verbose

try:
    import warnings
except ImportError:
    pass

warnings.filterwarnings('ignore', message = 'DB could not be closed in', category = RuntimeWarning)

class DBEnvClosedEarlyCrash(unittest.TestCase):
    
    def setUp(self):
        self.homeDir = os.path.join(os.path.dirname(sys.argv[0]), 'db_home')
        
        try:
            os.mkdir(self.homeDir)
        except os.error:
            pass

        tempfile.tempdir = self.homeDir
        self.filename = os.path.split(tempfile.mktemp())[1]
        tempfile.tempdir = None

    
    def tearDown(self):
        files = glob.glob(os.path.join(self.homeDir, '*'))
        for file in files:
            os.remove(file)
        

    
    def test01_close_dbenv_before_db(self):
        dbenv = db.DBEnv()
        dbenv.open(self.homeDir, db.DB_INIT_CDB | db.DB_CREATE | db.DB_THREAD | db.DB_INIT_MPOOL, 438)
        d = db.DB(dbenv)
        d.open(self.filename, db.DB_BTREE, db.DB_CREATE | db.DB_THREAD, 438)
        
        try:
            dbenv.close()
        except db.DBError:
            
            try:
                d.close()
            except db.DBError:
                return None

            if not 0:
                raise AssertionError, 'DB close did not raise an exception about its DBEnv being trashed'

        if not 0:
            raise AssertionError, 'dbenv did not raise an exception about its DB being open'

    
    def test02_close_dbenv_delete_db_success(self):
        dbenv = db.DBEnv()
        dbenv.open(self.homeDir, db.DB_INIT_CDB | db.DB_CREATE | db.DB_THREAD | db.DB_INIT_MPOOL, 438)
        d = db.DB(dbenv)
        d.open(self.filename, db.DB_BTREE, db.DB_CREATE | db.DB_THREAD, 438)
        
        try:
            dbenv.close()
        except db.DBError:
            pass

        del d
        
        try:
            import gc
        except ImportError:
            gc = None

        if gc:
            gc.collect()
        



def test_suite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(DBEnvClosedEarlyCrash))
    return suite

if __name__ == '__main__':
    unittest.main(defaultTest = 'test_suite')

