# Source Generated with Decompyle++
# File: in.pyo (Python 2.3)

'''Miscellaneous bsddb module test cases
'''
import os
import sys
import unittest

try:
    from bsddb import db, dbshelve
except ImportError:
    from bsddb3 import db, dbshelve


class MiscTestCase(unittest.TestCase):
    
    def setUp(self):
        self.filename = self.__class__.__name__ + '.db'
        homeDir = os.path.join(os.path.dirname(sys.argv[0]), 'db_home')
        self.homeDir = homeDir
        
        try:
            os.mkdir(homeDir)
        except OSError:
            pass


    
    def tearDown(self):
        
        try:
            os.remove(self.filename)
        except OSError:
            pass

        import glob
        files = glob.glob(os.path.join(self.homeDir, '*'))
        for file in files:
            os.remove(file)
        

    
    def test01_badpointer(self):
        dbs = dbshelve.open(self.filename)
        dbs.close()
        self.assertRaises(db.DBError, dbs.get, 'foo')

    
    def test02_db_home(self):
        env = db.DBEnv()
        env.open(self.homeDir, db.DB_CREATE)



def test_suite():
    return unittest.makeSuite(MiscTestCase)

if __name__ == '__main__':
    unittest.main(defaultTest = 'test_suite')

