# Source Generated with Decompyle++
# File: in.pyc (Python 2.3)

'''Module containing encoding functions for Image.Image and Text.Text.
'''
import base64

try:
    from quopri import encodestring as _encodestring
    
    def _qencode(s):
        enc = _encodestring(s, quotetabs = 1)
        return enc.replace(' ', '=20')

except ImportError:
    from cStringIO import StringIO
    import quopri as _quopri
    
    def _qencode(s):
        if not s:
            return s
        
        hasnewline = s[-1] == '\n'
        infp = StringIO(s)
        outfp = StringIO()
        _quopri.encode(infp, outfp, quotetabs = 1)
        value = outfp.getvalue().replace(' ', '=20')
        if not hasnewline and value[-1] == '\n':
            return value[:-1]
        
        return value



def _bencode(s):
    if not s:
        return s
    
    hasnewline = s[-1] == '\n'
    value = base64.encodestring(s)
    if not hasnewline and value[-1] == '\n':
        return value[:-1]
    
    return value


def encode_base64(msg):
    """Encode the message's payload in Base64.

    Also, add an appropriate Content-Transfer-Encoding header.
    """
    orig = msg.get_payload()
    encdata = _bencode(orig)
    msg.set_payload(encdata)
    msg['Content-Transfer-Encoding'] = 'base64'


def encode_quopri(msg):
    """Encode the message's payload in quoted-printable.

    Also, add an appropriate Content-Transfer-Encoding header.
    """
    orig = msg.get_payload()
    encdata = _qencode(orig)
    msg.set_payload(encdata)
    msg['Content-Transfer-Encoding'] = 'quoted-printable'


def encode_7or8bit(msg):
    '''Set the Content-Transfer-Encoding header to 7bit or 8bit.'''
    orig = msg.get_payload()
    if orig is None:
        msg['Content-Transfer-Encoding'] = '7bit'
        return None
    
    
    try:
        orig.encode('ascii')
    except UnicodeError:
        msg['Content-Transfer-Encoding'] = '8bit'

    msg['Content-Transfer-Encoding'] = '7bit'


def encode_noop(msg):
    '''Do nothing.'''
    pass

