# Source Generated with Decompyle++
# File: in.pyc (Python 2.3)

import unittest
import objc
import re
from Foundation import *

def stripDocType(val):
    '''
    Strip non-significant information. This is needed because the proplists
    on MacOS X 10.1 are slightly different from the ones on MacOS X 10.2 (
    different DOCTYPE and version).
    '''
    r = re.sub('<!DOCTYPE [^>]*>', '<!DOCTYPE>', val)
    return r.replace('version="0.9"', 'version="1.0"')


class TestNSNumber(unittest.TestCase):
    
    def testNSNumber(self):
        self.assertEquals(NSNumber.numberWithFloat_(1.0), 1, 0)
        self.assertEquals(NSNumber.numberWithInt_(1), 1)
        self.assertEquals(NSNumber.numberWithFloat_(-0.5), -0.5)
        self.assertEquals(NSNumber.numberWithInt_(-4), -4)
        self.assertEquals(NSNumber.numberWithInt_(0), 0)
        self.assertEquals(NSNumber.numberWithFloat_(0.0), 0, 0)


PLIST = '<?xml version="1.0" encoding="UTF-8"?>\n<!DOCTYPE plist PUBLIC "-//Apple Computer//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">\n<plist version="1.0">\n<dict>\n\t<key>bool</key>\n\t<true/>\n\t<key>plain</key>\n\t<integer>1</integer>\n</dict>\n</plist>\n'

class TestPropList(unittest.TestCase):
    '''
        Test if numbers are stored properly in property-list. The most 
        important part of the testcase are boolean values.
        '''
    
    def testPropertyList1(self):
        d = NSMutableDictionary.dictionary()
        d['plain'] = 1
        d['bool'] = objc.YES
        self.assertEquals(d.writeToFile_atomically_('/tmp/pyobjctest.plist', 0), 1)
        fd = open('/tmp/pyobjctest.plist', 'ru')
        data = fd.read()
        fd.close()
        self.assertEquals(stripDocType(data), stripDocType(PLIST))

    
    def testPropertyList2(self):
        d = NSMutableDictionary.dictionary()
        d['plain'] = NSNumber.numberWithLong_(1)
        d['bool'] = NSNumber.numberWithBool_(1)
        self.assertEquals(d.writeToFile_atomically_('/tmp/pyobjctest.plist', 0), 1)
        fd = open('/tmp/pyobjctest.plist', 'ru')
        data = fd.read()
        fd.close()
        self.assertEquals(stripDocType(data), stripDocType(PLIST))


if __name__ == '__main__':
    unittest.main()

