# Source Generated with Decompyle++
# File: in.pyc (Python 2.3)

'''An abstract base class for simple, character-oriented tokenizers.
'''
from tokenizer import Tokenizer
from token import Token
IO_BUFFER_SIZE = 1024
MAX_WORD_LEN = 255

class CharTokenizer(Tokenizer):
    __slots__ = [
        'buffer',
        'bufferIndex',
        'dataLen',
        'ioBuffer',
        'offset']
    
    def __init__(self, input):
        self.buffer = [
            0] * MAX_WORD_LEN
        self.bufferIndex = 0
        self.offset = 0
        self.dataLen = 0
        self.ioBuffer = ''
        self.input = input

    
    def isTokenChar(self, c):
        '''Returns true iff a character should be included in a token.  This
        * tokenizer generates as tokens adjacent sequences of characters which
        * satisfy this predicate.  Characters for which this is false are used to
        * define token boundaries and are not included in tokens.'''
        pass

    
    def next(self):
        length = 0
        start = self.offset
        while True:
            self.offset += 1
            if self.bufferIndex >= self.dataLen:
                self.ioBuffer = self.input.read(IO_BUFFER_SIZE)
                self.dataLen = len(self.ioBuffer)
                self.bufferIndex = 0
            
            if self.isTokenChar(c):
                if length == 0:
                    start = self.offset - 1
                
                self.buffer[length] = self.normalize(c)
                length += 1
                if length == MAX_WORD_LEN:
                    break
                
            length == MAX_WORD_LEN
            if length > 0:
                break
                continue
        tstr = ''.join(self.buffer[0:length])
        return Token(tstr, start, start + length)

    
    def normalize(self, c):
        '''Called on each token character to normalize it before it is added to the
        * token.  The default implementation does nothing.  Subclasses may use this
        * to, e.g., lowercase tokens'''
        return c


