# Source Generated with Decompyle++
# File: in.pyc (Python 2.3)

import string

class Splitter(object):
    '''Split plain text into words" utility class
    Adapted from David Mertz\'s article in IBM developerWorks
    Needs work to handle international characters, etc'''
    __slots__ = [
        'stemmer',
        'porter',
        'stopwording',
        'word_only',
        'nonword',
        'nondigits',
        'alpha',
        'ident',
        'tokens',
        'position']
    stopWords = {
        'and': 1,
        'be': 1,
        'to': 1,
        'that': 1,
        'into': 1,
        'it': 1,
        'but': 1,
        'as': 1,
        'are': 1,
        'they': 1,
        'in': 1,
        'not': 1,
        'such': 1,
        'with': 1,
        'by': 1,
        'is': 1,
        'if': 1,
        'a': 1,
        'on': 1,
        'for': 1,
        'no': 1,
        'these': 1,
        'of': 1,
        'there': 1,
        'this': 1,
        'will': 1,
        'their': 1,
        's': 1,
        't': 1,
        'then': 1,
        'the': 1,
        'was': 1,
        'or': 1,
        'at': 1 }
    yes = string.lowercase + string.digits + ''
    nonword = ''
    for i in range(0, 255):
        if chr(i) not in yes:
            nonword += chr(i)
            continue
    
    word_only = string.maketrans(nonword, ' ' * len(nonword))
    nondigits = string.join(map(chr, range(0, 48)) + map(chr, range(58, 255)), '')
    alpha = string.join(map(chr, range(65, 91)) + map(chr, range(97, 123)), '')
    ident = string.join(map(chr, range(256)), '')
    
    def close(self):
        pass

    
    def tokenStream(self, fieldName, file, casesensitive = False):
        '''Split text/plain string into a list of words
        '''
        self.tokens = self.split(file.read())
        self.position = 0
        return self

    
    def next(self):
        if self.position >= len(self.tokens):
            return None
        
        res = Token(self.tokens[self.position])
        self.position += 1
        return res

    
    def split(self, text, casesensitive = 0):
        word_only = self.word_only
        ident = self.ident
        alpha = self.alpha
        nondigits = self.nondigits
        if not casesensitive:
            text = string.lower(text)
        
        allwords = text.translate(word_only).split()
        words = []
        for word in allwords:
            if len(word) > 32:
                continue
            
            num_nonalpha = len(word.translate(ident, alpha))
            numdigits = len(word.translate(ident, nondigits))
            if numdigits > len(word) - 2:
                if numdigits > 5:
                    continue
                
            elif num_nonalpha * 2 > len(word):
                continue
            
            word = word.translate(word_only)
            subwords = word.split()
            for subword in subwords:
                if len(subword) <= 1:
                    continue
                
                words.append(subword)
            
        
        return words



class Token:
    
    def __init__(self, trmText):
        self.trmText = trmText

    
    def termText(self):
        return self.trmText


