# Source Generated with Decompyle++
# File: in.pyc (Python 2.3)

'''A Token is an occurence of a term from the text of a field.  It consists of
  a term\'s text, the start and end offset of the term in the text of the field,
  and a type string.

  The start and end offsets permit applications to re-associate a token with
  its source text, e.g., to display highlighted query terms in a document
  browser, or to show matching text fragments in a KWIC (KeyWord In Context)
  display, etc.

  The type is an interned string, assigned by a lexical analyzer
  (a.k.a. tokenizer), naming the lexical or syntactic class that the token
  belongs to.  For example an end of sentence marker token might be implemented
  with type "eos".  The default token type is "word".
  '''

class Token(object):
    __slots__ = [
        'endOffsett',
        'startOffsett',
        'termTextt',
        'typpe']
    
    def __init__(self, text, start, end, typ = 'word'):
        self.termTextt = text
        self.startOffsett = start
        self.endOffsett = end
        self.typpe = typ

    
    def endOffset(self):
        return self.endOffsett

    
    def startOffset(self):
        return self.startOffsett

    
    def type(self):
        return self.typpe

    
    def termText(self):
        return self.termTextt


