# Source Generated with Decompyle++
# File: in.pyc (Python 2.3)


class FieldsWriter(object):
    __slots__ = [
        'fieldInfos',
        'fieldsStream',
        'indexStream']
    
    def __init__(self, d, segment, fn):
        self.fieldInfos = fn
        self.fieldsStream = d.createFile(segment + '.fdt')
        self.indexStream = d.createFile(segment + '.fdx')

    
    def addDocument(self, doc):
        self.indexStream.writeLong(self.fieldsStream.getFilePointer())
        storedCount = 0
        for field in doc.fields():
            if field.isStored:
                storedCount += 1
                continue
        
        self.fieldsStream.writeVInt(storedCount)
        for field in doc.fields():
            if field.isStored:
                self.fieldsStream.writeVInt(self.fieldInfos.fieldNumber(field.name()))
                bits = 0
                if field.isTokenized:
                    bits |= 1
                
                self.fieldsStream.writeByte(bits)
                self.fieldsStream.writeString(field.stringValue())
                continue
        

    
    def close(self):
        self.fieldsStream.close()
        self.indexStream.close()


