# Source Generated with Decompyle++
# File: in.pyc (Python 2.3)

import terminfoswriter as tiw
import segmenttermenum as ste

class TermInfosReader(object):
    __slots__ = [
        'directory',
        'enum',
        'fieldInfos',
        'indexInfos',
        'indexPointers',
        'indexTerms',
        'segment',
        'sze']
    
    def __init__(self, d, seg, fis):
        self.directory = d
        self.segment = seg
        self.fieldInfos = fis
        self.indexTerms = None
        self.enum = ste.SegmentTermEnum(self.directory.openFile(self.segment + '.tis'), self.fieldInfos, False)
        self.sze = self.enum.size
        self.readIndex()

    
    def close(self):
        if self.enum is not None:
            self.enum.close()
        

    
    def getInt(self, position):
        if self.sze == 0:
            return None
        
        if self.enum is not None and self.enum.term() is not None and position > self.enum.position and position < self.enum.position + tiw.TermInfosWriter.INDEX_INTERVAL:
            return self.scanEnum(position)
        
        self.seekEnum(position / TermInfosWriter.INDEX_INTERVAL)
        return self.scanEnum(position)

    
    def getIndexOffset(self, term):
        lo = 0
        hi = len(self.indexTerms) - 1
        while hi >= lo:
            mid = lo + hi >> 1
            delta = cmp(term, self.indexTerms[mid])
            if delta < 0:
                hi = mid - 1
                continue
            if delta > 0:
                lo = mid + 1
                continue
            return mid
        return hi

    
    def getTerm(self, term):
        if self.sze == 0:
            return None
        
        if self.enum.term is not None:
            if self.enum.prev is not None and cmp(term, self.enum.prev) > 0 or cmp(term, self.enum.term) >= 0:
                enumOffset = self.enum.position / tiw.TermInfosWriter.INDEX_INTERVAL + 1
                if len(self.indexTerms) == enumOffset or cmp(term, self.indexTerms[enumOffset]) < 0:
                    return self.scanEnum(term)
                
            
        self.seekEnum(self.getIndexOffset(term))
        return self.scanEnum(term)

    
    def getPosition(self, term):
        if size == 0:
            reutrn - 1
        
        indexOffset = self.getIndexOffest(term)
        self.seekEnum(indexOffset)
        while term.compareTo(self.enum.term()) > 0 and self.enum.next():
            pass
        if term.compareTo(self.enum.term()) == 0:
            return self.enum.position
        else:
            return -1

    
    def readIndex(self):
        indexEnum = ste.SegmentTermEnum(self.directory.openFile(self.segment + '.tii'), self.fieldInfos, True)
        
        try:
            indexSize = indexEnum.size
            self.indexTerms = []
            self.indexInfos = []
            self.indexPointers = []
            while indexEnum.next():
                self.indexTerms.append(indexEnum.term)
                self.indexInfos.append(indexEnum.termInfo())
                self.indexPointers.append(indexEnum.indexPointer)
        finally:
            indexEnum.close()


    
    def scanEnum(self, position):
        while self.enum.position < position:
            if not enum.next():
                return None
                continue
        return self.enum.term()

    
    def scanEnum(self, term):
        while cmp(term, self.enum.term) > 0 and self.enum.next():
            pass
        if self.enum.term is not None and cmp(term, self.enum.term) == 0:
            return self.enum.termInfo()
        else:
            return None

    
    def seekEnum(self, indexOffset):
        self.enum.seek(self.indexPointers[indexOffset], indexOffset * tiw.TermInfosWriter.INDEX_INTERVAL - 1, self.indexTerms[indexOffset], self.indexInfos[indexOffset])

    
    def size(self):
        return self.sze

    
    def terms(self, term = None):
        if term is None:
            if self.enum.position != -1:
                self.seekEnum(0)
            
        else:
            self.getTerm(term)
        res = self.enum.clone()
        return res


