# Source Generated with Decompyle++
# File: in.pyc (Python 2.3)

'''Superclass for L{ExactPhraseScorer} and L{SloppyPhraseScorer}.'''
import lupy.util.priorityqueue as priorityqueue
import similarity
import phrasequeue
import scorer
import phrasepositions

class PhraseScorer(scorer.Scorer):
    slots = [
        'first',
        'last',
        'norms',
        'pq',
        'weight']
    
    def __init__(self, tps, n, w):
        self.norms = n
        self.weight = w
        self.pq = phrasequeue.PhraseQueue()
        i = 0
        for tp in tps:
            self.pq.put(phrasepositions.PhrasePositions(tp, i))
            i += 1
        
        self.pqToList()

    
    def firstToLast(self):
        self.last.nxt = self.first
        self.last = self.first
        self.first = self.first.nxt
        self.last.nxt = None

    
    def phraseQuery(self):
        '''Subclass responsibility'''
        pass

    
    def pqToList(self):
        self.last = None
        self.first = None
        while self.pq.top() is not None:
            pp = self.pq.pop()
            if self.last is not None:
                self.last.nxt = pp
            else:
                self.first = pp
            self.last = pp
            pp.nxt = None

    
    def score(self, results, end):
        while self.last.doc < end:
            while self.first.doc < self.last.doc:
                self.first.next()
                while self.first.doc < self.last.doc:
                    self.first.next()
                self.firstToLast()
                if self.last.doc >= end:
                    return None
                    continue
            freq = self.phraseFreq()
            if freq > 0.0:
                score = similarity.tf(freq) * self.weight
                score *= similarity.normByte(self.norms[self.first.doc])
                results.collect(self.first.doc, score)
            
            self.last.next()


