# Source Generated with Decompyle++
# File: in.pyc (Python 2.3)

'''Scorer for L{TermQuery}s.'''
import scorer
import similarity
import sys

class TermScorer(scorer.Scorer):
    __slots__ = [
        'doc',
        'docs',
        'freqs',
        'norms',
        'pointer',
        'pointerMax',
        'scorerCache',
        'termDocs',
        'weight']
    SCORE_CACHE_SIZE = 32
    
    def __init__(self, td, n, w):
        self.termDocs = td
        self.norms = n
        self.weight = w
        self.pointer = 0
        self.docs = [
            0] * 128
        self.freqs = [
            0] * 128
        self.scoreCache = [
            0.0] * self.SCORE_CACHE_SIZE
        for i in range(len(self.scoreCache)):
            self.scoreCache[i] = similarity.tf(i) * self.weight
        
        self.pointerMax = self.termDocs.read(self.docs, self.freqs)
        if self.pointerMax != 0:
            self.doc = self.docs[0]
        else:
            self.termDocs.close()
            self.doc = sys.maxint

    
    def score(self, c, end):
        d = self.doc
        while d < end:
            f = self.freqs[self.pointer]
            if f < self.SCORE_CACHE_SIZE:
                score = self.scoreCache[f]
            else:
                score = similarity.tf(f) * self.weight
            score *= similarity.normByte(self.norms[d])
            c.collect(d, score)
            self.pointer += 1
            if self.pointer == self.pointerMax:
                self.pointerMax = self.termDocs.read(self.docs, self.freqs)
                if self.pointerMax != 0:
                    self.pointer = 0
                else:
                    self.termDocs.close()
                    self.doc = sys.maxint
                    return None
            
            d = self.docs[self.pointer]
        self.doc = d


