# Source Generated with Decompyle++
# File: in.pyc (Python 2.3)

from array import array

def byte(i):
    return i & 255


def mint(i):
    '''My int cast'''
    return i & -1


class OutputStream(object):
    __slots__ = [
        'buffer',
        'bufferStart',
        'bufferPosition',
        'length']
    BUFFER_SIZE = 1024
    
    def __init__(self):
        self.buffer = array('B', [
            0] * self.BUFFER_SIZE)
        self.bufferStart = 0
        self.bufferPosition = 0

    
    def writeByte(self, b):
        if self.bufferPosition >= self.BUFFER_SIZE:
            self.flush()
        
        self.buffer[self.bufferPosition] = b
        self.bufferPosition += 1

    
    def writeBytes(self, b, length):
        for i in xrange(length):
            self.writeByte(b[i])
        

    
    def writeInt(self, i):
        self.writeByte(byte(i >> 24))
        self.writeByte(byte(i >> 16))
        self.writeByte(byte(i >> 8))
        self.writeByte(byte(i))

    
    def writeVInt(self, i):
        while i & -128 != 0:
            self.writeByte(i & 127 | 128)
            i = i >> 7
        self.writeByte(i)

    
    def writeLong(self, i):
        self.writeInt(mint(i >> 32))
        self.writeInt(mint(i))

    
    def writeVLong(self, i):
        while i & -128 != 0:
            self.writeByte(i & 127 | 128)
            i = i >> 7
        self.writeByte(i)

    
    def writeString(self, s):
        length = len(s)
        self.writeVInt(length)
        self.writeChars(s, 0, length)

    
    def writeChars(self, s, start, length):
        end = start + length
        for i in xrange(start, end):
            code = ord(s[i])
            if code >= 1 and code <= 127:
                self.writeByte(code)
                continue
            if code > 128 and code <= 2047 or code == 0:
                self.writeByte(192 | code >> 6)
                self.writeByte(128 | code & 63)
                continue
            self.writeByte(224 | code >> 12)
            self.writeByte(128 | code >> 6 & 63)
            self.writeByte(128 | code & 63)
        

    
    def flush(self):
        self.flushBuffer(self.buffer, self.bufferPosition)
        self.bufferStart += self.bufferPosition
        self.bufferPosition = 0

    
    def flushBuffer(self, b, len):
        '''???'''
        pass

    
    def close(self):
        self.flush()

    
    def getFilePointer(self):
        return self.bufferStart + self.bufferPosition

    
    def seek(self, pos):
        self.flush()
        self.bufferStart = pos

    
    def length(self):
        raise NotImplementedError()


