# Source Generated with Decompyle++
# File: in.pyc (Python 2.3)

from util import ContextContainer
import mycookie
import Cookie
import cgi
import sys
import codecs
from util import NormalizedHeaderDict
from webform import *

class Request:
    
    def __init__(self, webapp, pathinfo, query, server, ins):
        self.webapp = webapp
        self.ins = ins
        self.server = server
        self.context = ContextContainer()
        self.session = None
        self._auth_user = None
        self._auth_passwd = None
        self.env = { }
        self._init_query(pathinfo, query)
        self.env['REQUEST_METHOD'] = server.command
        if not server.headers.typeheader:
            pass
        self.env['CONTENT_TYPE'] = server.headers.type
        if not server.headers.getheader('content-length'):
            pass
        self.env['CONTENT_LENGTH'] = -1
        co = filter(None, server.headers.getheaders('cookie'))
        if co:
            self.HTTP_COOKIE = ', '.join(co)
        else:
            self.HTTP_COOKIE = None
        self.cookies = mycookie.SimpleRequestCookie()
        if self.HTTP_COOKIE:
            self.cookies.load(self.HTTP_COOKIE)
        
        self.maxPOSTsize = 200000
        self.setEncoding(None)

    
    def _init_query(self, pathinfo, query):
        self.PATH_INFO = pathinfo
        self.arg = None
        possible_query_arg = query.split('&', 1)
        if '=' not in possible_query_arg[0]:
            self.arg = possible_query_arg[0]
            if len(possible_query_arg) > 1:
                query = possible_query_arg[1]
            else:
                query = ''
        
        if not query:
            pass
        self.QUERY_STRING = self.env['QUERY_STRING'] = ''
        self._cgi_form = None

    
    def getServerSoftware(self):
        return self.server.version_string()

    
    def getSnakeletsVersion(self):
        return self.server.snakelets_version

    
    def getServerIP(self):
        return self.server.getServerIP()

    
    def getServerName(self):
        return self.server.getServerName()

    
    def getRealServerName(self):
        return self.server.getRealServerName()

    
    def getServerProtocol(self):
        return self.server.protocol_version

    
    def getServerPort(self):
        return self.server.server.server_port

    
    def getBaseURL(self):
        return self.server.getBaseURL()

    
    def getPathInfo(self):
        return self.PATH_INFO

    
    def getMethod(self):
        return self.env['REQUEST_METHOD']

    
    def setMethod(self, method):
        self.env['REQUEST_METHOD'] = method

    
    def getQuery(self):
        return self.QUERY_STRING

    
    def getRequestURL(self):
        return self.server.path

    
    def getRequestURLplain(self):
        return self.server.path.split('?')[0]

    
    def getRemoteHost(self):
        return self.server.address_string()

    
    def getRemoteAddr(self):
        return self.server.client_address[0]

    
    def getContentType(self):
        return self.env['CONTENT_TYPE']

    
    def getContentLength(self):
        return self.env['CONTENT_LENGTH']

    
    def getUserAgent(self):
        if not self.server.headers.getheader('user-agent'):
            pass
        return ''

    
    def getCookie(self):
        return self.HTTP_COOKIE

    
    def getCookies(self):
        return self.cookies

    
    def clearCookies(self):
        self.HTTP_COOKIE = None
        self.cookies = mycookie.SimpleRequestCookie()

    
    def getInput(self):
        return self.ins

    
    def getArg(self):
        return self.arg

    
    def setArg(self, arg):
        self.arg = arg

    
    def getWebApp(self):
        return self.webapp

    
    def getRangeStr(self):
        if not self.server.headers.getheader('range'):
            pass
        return ''

    
    def getRange(self):
        rangeStr = self.getRangeStr()
        if rangeStr:
            (t, r) = rangeStr.split('=')
            if t.lower() == 'bytes':
                (frm, to) = r.split('-')
                if frm:
                    frm = int(frm)
                else:
                    frm = 0
                if to:
                    to = int(to)
                else:
                    to = sys.maxint
                return (frm, to)
            else:
                raise ValueError('only supports range header in BYTES')
        else:
            return None

    
    def getRealRemoteAddr(self):
        if not self.server.headers.get('x-forwarded-for'):
            pass
        return self.getRemoteAddr()

    
    def getAuth(self):
        if not self.server.headers.getheader('Authorization'):
            pass
        return ''

    
    def getAuthenticatedUserPW(self):
        return (self._auth_user, self._auth_passwd)

    
    def getAllHeaders(self):
        return self.server.headers

    
    def getHeader(self, header):
        return self.server.headers[header]

    
    def getForm(self):
        if self._cgi_form is not None:
            return self._cgi_form
        else:
            
            try:
                (maxlen, cgi.maxlen) = (cgi.maxlen, self.maxPOSTsize)
                
                try:
                    self._cgi_form = Form(cgi.FieldStorage(fp = self.ins, environ = self.env), self.getEncoding())
                except ValueError:
                    x = None
                    raise FormFileUploadError(x)

                if self.getMethod() == 'POST':
                    extraParams = { }
                    for key, value in cgi.parse_qsl(self.getQuery()):
                        extraParams.setdefault(key, []).append(value)
                    
                    for key in extraParams:
                        if key in self._cgi_form:
                            self._cgi_form[key].extend(extraParams[key])
                            continue
                        self._cgi_form[key] = extraParams[key]
                    
                
                self._cgi_form.simplifyValues()
                return self._cgi_form
            finally:
                cgi.maxlen = maxlen


    
    def setParameter(self, param, value):
        self.getForm()[param] = value

    
    def getParameter(self, param, default = ''):
        return self.getForm().get(param, default)

    
    def getContext(self):
        return self.context

    
    def setSession(self, session):
        self.session = session

    
    def getSession(self):
        return self.session

    
    def deleteSession(self):
        self.session.destroy()
        self.clearCookies()

    
    def getSessionContext(self):
        return self.session.getContext()

    
    def setMaxPOSTsize(self, numbytes):
        self.maxPOSTsize = numbytes

    
    def getMaxPOSTsize(self):
        return self.maxPOSTsize

    
    def getEncoding(self):
        return self.charEncoding

    
    def setEncoding(self, encoding):
        self.charEncoding = encoding

    
    def setAuthenticatedUserPW(self, user, passwd):
        self._auth_user = user
        self._auth_passwd = passwd

    
    def getFullQueryArgs(self):
        if not self.getPathInfo():
            pass
        qa = ''
        if self.getQuery() or self.getArg():
            qa += '?'
        
        if self.getArg():
            qa += self.getArg()
            if self.getQuery():
                qa += '&'
            
        
        if self.getQuery():
            qa += self.getQuery()
        
        return qa



class Response:
    
    def __init__(self, server, outs):
        self.server = server
        self._outs = self.outs = outs
        self.content_type = 'text/html'
        self.content_encoding = None
        self.content_length = -1
        self.content_disposition = None
        self.header_written = False
        self.error_sent = False
        self.redirection_performed = False
        self.response_code = 200
        self.response_string = 'OK'
        self.userHeaders = NormalizedHeaderDict()
        self.cookies = Cookie.SimpleCookie()

    
    def getDummy(self, output):
        dummy = Response(None, output)
        dummy.header_written = True
        dummy.error_sent = True
        return dummy

    
    def setContentType(self, type):
        self.content_type = type

    
    def setContentDisposition(self, disposition):
        self.content_disposition = disposition

    
    def setContentLength(self, len):
        self.content_length = len

    
    def setEncoding(self, encoding):
        self.content_encoding = encoding
        if encoding:
            if sys.version_info[:2] >= (2, 3):
                errs = 'xmlcharrefreplace'
            else:
                errs = 'replace'
            self.outs = codecs.getwriter(encoding)(self._outs, errors = errs)
        else:
            self.outs = self._outs

    
    def guessMimeType(self, filename):
        return self.server.guess_type(filename)

    
    def setHeader(self, header, value):
        self.userHeaders[header] = value

    
    def setResponse(self, code, msg = 'Snakelet output follows'):
        self.response_code = code
        self.response_string = msg

    
    def HTTPredirect(self, URL):
        if self.header_written:
            raise RuntimeError('can not redirect when getOutput() has been called')
        
        self.setResponse(302)
        self.setHeader('Location', URL)
        out = self.getOutput()
        out.write('<html><head><title>Redirection</title></head>\n<body><h1>Redirection</h1>\nYou\'re being <a href="' + URL + '">redirected</a>.</body></html>')
        self.setRedirectionDone()

    
    def writeHeader(self):
        if self.header_written:
            raise RuntimeError('header has already been written')
        
        self.server.send_response(self.response_code, self.response_string)
        contentType = self.content_type
        if self.content_encoding:
            contentType += '; charset=' + self.content_encoding
        
        self.setHeader('Content-Type', contentType)
        if self.content_disposition:
            self.setHeader('Content-Disposition', self.content_disposition)
        
        if self.content_length >= 0:
            self.setHeader('Content-Length', str(self.content_length))
        
        for h, v in self.userHeaders.iteritems():
            self.server.send_header(h, v)
        
        for c in self.cookies.values():
            self.server.send_header('Set-Cookie', c.OutputString())
        
        self.server.end_headers()
        self.header_written = True

    
    def getOutput(self):
        if self.redirection_performed:
            raise RuntimeError('cannot write after redirect() call')
        
        if not (self.header_written):
            self.writeHeader()
        
        return self.outs

    
    def sendError(self, code, message = None):
        if not (self.header_written):
            self.error_sent = True
            self.header_written = True
            self.server.send_error(code, message, self.userHeaders)
        else:
            raise RuntimeError('cannot send error after header has been written')

    
    def getCookies(self):
        return self.cookies

    
    def setCookie(self, name, value, path = None, domain = None, maxAge = None, comment = None, secure = None):
        self.cookies[name] = value
        self.cookies[name]['version'] = 1
        self.cookies[name]['path'] = ''
        self.cookies[name]['domain'] = ''
        self.cookies[name]['max-age'] = ''
        self.cookies[name]['expires'] = ''
        self.cookies[name]['comment'] = ''
        self.cookies[name]['secure'] = ''
        if path:
            self.cookies[name]['path'] = path
        
        if domain:
            self.cookies[name]['domain'] = domain
        
        if maxAge != None:
            self.cookies[name]['max-age'] = maxAge
            self.cookies[name]['expires'] = maxAge
        
        if comment:
            self.cookies[name]['comment'] = comment
        
        if secure:
            self.cookies[name]['secure'] = secure
        
        self.setHeader('P3P', "CP='CUR ADM OUR NOR STA NID'")

    
    def delCookie(self, name, path = None, domain = None, comment = None, secure = None):
        self.setCookie(name, 'discarded', path, domain, 0, comment, secure)

    
    def setRedirectionDone(self):
        self.redirection_performed = True

    
    def used(self):
        if not self.redirection_performed and self.header_written:
            pass
        return self.error_sent

    
    def kill(self):
        self.server.kill()
        self.error_sent = True

    
    def initiateRedirection(self, url, isInclude = False):
        if self.header_written:
            self.outs.flush()
        elif not isInclude:
            self.setHeader('Content-Location', url)
        else:
            self.writeHeader()

    
    def wasErrorSent(self):
        return self.error_sent

    
    def YswitchOutput(self, output):
        oldout = self._outs
        self._outs = self.outs = output
        return oldout

    
    def forceFlush(self, stream):
        out = self.getOutput()
        stream.flush()
        if hasattr(out, 'fileno'):
            if out.fileno() == stream.fileno():
                return None
            else:
                del out
                del stream
                raise IOError("response is a stream but not the socket. Don't know how to handle this. Bail out")
        
        out.seek(0)
        self.server.copyfile(out, stream)
        out.seek(0)
        out.truncate()


