# Source Generated with Decompyle++
# File: in.pyc (Python 2.3)

import SocketServer
import mimetypes
import urllib
import socket
import select
import os
import time
import sys
import types
import copy
import shutil
import BaseHTTPServer
import dirlister
import webapp
import cStringIO

try:
    from sendfile import sendfile
    print 'sendfile(2) is available for high performance file serving'
except ImportError:
    print 'sendfile(2) is NOT available, compatible but slower file serving is used'
    sendfile = None

SNAKELETS_VERSION = 'Snakelets 1.23'

class MyRequestHandler(BaseHTTPServer.BaseHTTPRequestHandler):
    rbufsize = -1
    wbufsize = 1024
    snakelets_version = SNAKELETS_VERSION
    server_version = SNAKELETS_VERSION.replace(' ', '/')
    protocol_version = 'HTTP/1.1'
    error_message_format = '<head>\n<title>Error %(code)d</title>\n</head>\n<body>\n<h1>Error response</h1>\n<p>%(code)s = %(explain)s.\n<p>Server message: %(message)s.\n<p><hr><address>' + server_version + ' Python/' + sys.version.split()[0] + '<br>If the problem remains, please contact webmaster @ this domain.</body>'
    extensions_map = mimetypes.types_map.copy()
    extensions_map.update({
        '': 'text/plain',
        '.mp3': 'audio/mpeg',
        '.m3u': 'audio/x-mpegurl',
        '.y': 'text/html',
        '.py': 'text/plain',
        '.jar': 'application/x-jar',
        '.class': 'application/x-java-class',
        '.ogg': 'application/ogg' })
    
    def setup(self):
        if self.server.debugRequests:
            print '\n>>>>> GOT HTTP REQUEST #%d, from %s' % (self.server.requestCounter, self.client_address[0])
        
        BaseHTTPServer.BaseHTTPRequestHandler.setup(self)
        self.startTimeCPU = time.clock()
        self.startTimeReal = time.time()

    
    def finish(self):
        
        try:
            BaseHTTPServer.BaseHTTPRequestHandler.finish(self)
        except socket.error:
            x = None
            print 'Socket error during flush:', x

        self.processTimeCPU = time.clock() - self.startTimeCPU
        self.processTimeReal = time.time() - self.startTimeReal
        if self.server.debugRequests:
            print '<<<<< REQUEST TOOK: %d msec. CPU, %d msec. real' % (int(self.processTimeCPU * 1000), int(self.processTimeReal * 1000))
        

    
    def handle_one_request(self):
        '''Handle a single HTTP request. overridden from base class'''
        self.raw_requestline = self.rfile.readline()
        if self.server.debugRequests:
            print 'REQUEST=', self.raw_requestline.rstrip()
        
        if not (self.raw_requestline):
            self.close_connection = 1
            return None
        
        if not self.parse_request():
            return None
        
        if self.server.debugRequests:
            print 'HEADERS FOLLOW:'
            print self.headers
            print '--- end of headers'
        
        (self.virtualhost, self.virtualhostport) = urllib.splitport(self.headers.get('host', ''))
        x_host = self.headers.get('X-Forwarded-Host')
        if x_host:
            (self.virtualhost, self.virtualhostport) = urllib.splitport(x_host)
        
        if not (self.virtualhost):
            (self.virtualhost, self.virtualhostport) = self.server.defaultVirtualHost
        
        if not self.server.externalPort:
            pass
        self.virtualhostport = int(self.virtualhostport)
        if self.server.debugRequests:
            print 'REQUEST IS FOR VHOST %s : %d' % (self.virtualhost, self.virtualhostport)
        
        self.server.requestCounter += 1
        mname = 'do_' + self.command
        if not hasattr(self, mname):
            self.send_error(501, 'Unsupported method (%s)' % `self.command`)
            return None
        
        method = getattr(self, mname)
        method()

    
    def do_PING(self):
        self.path = '/'
        self.send_error(202)

    
    def do_GET(self):
        self.path = self.checkRelativePath(self.path)
        if self.path:
            f = self.send_head()
            if f:
                self.copyfile(f, self.wfile)
                f.close()
            
        

    
    def do_HEAD(self):
        self.path = self.checkRelativePath(self.path)
        if self.path:
            f = self.send_head()
            if f:
                f.close()
            
        

    
    def do_POST(self):
        self.path = self.checkRelativePath(self.path)
        if self.path:
            web = self.server.getWebApp(self.path, self.virtualhost)
            return web.do_POST(self)
        
        return None

    
    def checkRelativePath(self, path):
        if path.find('/./') >= 0 or path.find('/../') >= 0:
            self.send_error(400, 'Unsupported url path notation with relative directories')
            return None
        
        return path

    
    def kill(self):
        
        try:
            self.connection.close()
            os.close(self.wfile.fileno())
            os.close(self.rfile.fileno())
        except:
            pass


    
    def log_message(self, format, *args):
        sys.stdout.write('%s - - [%s] %s\n' % (self.address_string(), self.log_date_time_string(), format % args))
        sys.stdout.flush()

    
    def send_head(self, passtroughRequest = None, passtroughResponse = None):
        web = self.server.getWebApp(self.path, self.virtualhost)
        if not web:
            self.send_error(404, 'File not found (no context enabled for URL ' + self.path + ')')
            return None
        
        path = urllib.url2pathname(self.path)
        path = os.path.join(web.getDocRootPath(), path[len(web.getURLprefix()):])
        if os.path.isdir(path):
            if self.path.endswith('/'):
                for index in self.server.INDEXPAGES:
                    indexf = os.path.join(path, index)
                    if os.path.exists(indexf):
                        path = indexf
                        self.path = os.path.join(self.path, index)
                        break
                        continue
                else:
                    return self.list_directory(web, path, passtroughResponse)
            else:
                return self._redirectToProperDirectoryURL(urllib.unquote(self.path), passtroughResponse)
        
        if not web.allowDocument(self.path):
            if not passtroughResponse or not passtroughResponse.used():
                print "404-->webapp doesn't allow loading ", self.path
                self.send_error(404)
            else:
                passtroughResponse.getOutput().write('No permission (by server config) to view document ' + path)
            return None
        
        
        try:
            if self.command == 'GET':
                return web.do_GET(self, passtroughRequest, passtroughResponse)
            elif self.command == 'HEAD':
                return web.do_HEAD(self)
            elif not passtroughResponse or not passtroughResponse.used():
                self.send_error(501)
            else:
                passtroughResponse.getOutput().write('Unsupported method ' + self.command)
        except webapp.NotHandled:
            path = urllib.splitquery(path)[0]
            ctype = self.guess_type(path)
            
            try:
                f = open(path, 'rb')
                stats = os.stat(path)
            except IOError:
                if not passtroughResponse or not passtroughResponse.used():
                    print '404-->file does not exist:', path
                    self.send_error(404)
                else:
                    passtroughResponse.getOutput().write('File not found: ' + path)
                return None

            if not passtroughResponse or not passtroughResponse.used():
                (etag, lmod) = web.create_ETag_LMod_headers(stats.st_mtime, stats.st_size, stats.st_ino)
                if self.handleIfModifiedSince(stats, etag, lmod, ctype):
                    f.close()
                    return None
                else:
                    self.send_response(200)
                    self.send_header('Content-Type', ctype)
                    self.send_header('Content-Length', stats.st_size)
                    self.send_header('ETag', etag)
                    self.send_header('Last-Modified', lmod)
                    self.end_headers()
                if passtroughResponse:
                    passtroughResponse.header_written = True
                
            
            return f


    
    def handleIfModifiedSince(self, stats, etag, lmod, contenttype):
        IfModifiedSince = self.headers.get('If-Modified-Since', '')
        IfNoneMatch = self.headers.get('If-None-Match', '')
        if not IfModifiedSince and not IfNoneMatch or self.headers.get('Pragma') == 'No-cache':
            return False
        
        index = IfModifiedSince.find(';')
        if index >= 0:
            IfModifiedSince = IfModifiedSince[:index]
        
        if IfNoneMatch and IfNoneMatch != '*' and etag != IfNoneMatch:
            return False
        
        if lmod != IfModifiedSince:
            return False
        
        self.send_response(304)
        self.send_header('ETag', etag)
        self.end_headers()
        return True

    
    def send_error(self, code, message = None, userHeaders = None):
        
        try:
            (short, lng) = self.responses[code]
        except KeyError:
            (short, lng) = ('???', '???')

        if message is None:
            message = short
        
        explain = lng
        self.log_error('code %d, message %s', code, message)
        content = self.error_message_format % {
            'code': code,
            'message': message,
            'explain': explain }
        self.send_response(code, message)
        self.send_header('Content-Type', 'text/html')
        if userHeaders:
            for h in userHeaders:
                self.send_header(h, userHeaders[h])
            
        
        self.end_headers()
        if self.command != 'HEAD' and code >= 200 and code not in (204, 304):
            self.wfile.write(content)
            self.wfile.flush()
        

    
    def send_response(self, code, msg = None):
        BaseHTTPServer.BaseHTTPRequestHandler.send_response(self, code, msg)
        self.send_header('Connection', 'close')

    
    def getServerIP(self):
        return self.request.getsockname()[0]

    
    def getServerName(self):
        if not (self.virtualhostport) or self.virtualhostport == 80:
            return self.virtualhost
        else:
            return '%s:%d' % (self.virtualhost, self.virtualhostport)

    
    def getRealServerName(self):
        return self.server.getHostName(self.getServerIP())

    
    def guess_type(self, path):
        (base, ext) = os.path.splitext(path)
        if self.extensions_map.has_key(ext):
            return self.extensions_map[ext]
        
        ext = ext.lower()
        if self.extensions_map.has_key(ext):
            return self.extensions_map[ext]
        else:
            return self.extensions_map['']

    
    def getBaseURL(self):
        return 'http://' + self.getServerName()

    
    def list_directory(self, webapp, physicalpath, passtroughResponse = None):
        path = urllib.unquote(self.path)
        if not webapp.allowDirListing(path):
            if not passtroughResponse or not passtroughResponse.used():
                self.send_error(403)
            else:
                passtroughResponse.getOutput().write('No permission (by server config) to list directory ' + path)
            return None
        
        if path and not path.endswith('/'):
            return self._redirectToProperDirectoryURL(path, passtroughResponse)
        
        
        try:
            (filelist, dirlist) = dirlister.listdir(physicalpath)
            filelist.sort((lambda a, b: cmp(a.lower(), b.lower())))
            dirlist.sort((lambda a, b: cmp(a.lower(), b.lower())))
            f = cStringIO.StringIO()
            f.write('<head>\n<title>Directory listing for %s</title>\n</head>\n' % path + '<body>\n<h2>Directory listing for %s</h2>\n<hr>\n' % path)
            if path:
                f.write('<a href="..">parent directory</a>')
            
            f.write('<hr>\n\n<address>Server: Python ' + self.server_version + '</address>\n</body>')
            size = f.tell()
            f.seek(0)
            if not passtroughResponse or not passtroughResponse.used():
                self.send_response(200, 'Directory content follows')
                self.send_header('Content-type', 'text/html')
                self.send_header('Content-length', str(size))
                self.end_headers()
            
            if self.command == 'HEAD':
                return None
            
            return f
        except os.error:
            if not passtroughResponse or not passtroughResponse.used():
                self.send_error(403)
            else:
                passtroughResponse.getOutput().write('No permission to list directory ' + path)
            return None


    
    def _redirectToProperDirectoryURL(self, path, passtroughResponse):
        f = cStringIO.StringIO()
        f.write('<html><head><title>Redirection</title></head>\n<body>For correct directory listing, you\'re being <a href="' + path + '/">redirected</a>.</body></html>')
        if not passtroughResponse or not passtroughResponse.used():
            self.send_response(302, 'Document moved')
            self.send_header('Content-type', 'text/html')
            path = self.getBaseURL() + path + '/'
            self.send_header('Location', path)
            self.end_headers()
        
        f.seek(0)
        return f

    
    def translate_path(self, path):
        path = os.path.normpath(urllib.unquote(path))
        web = self.server.getWebApp(self.path, self.virtualhost)
        path = os.path.join(web.getDocRootPath(), path[len(web.getURLprefix()):])
        return path

    
    def copyfile(self, source, outputfile):
        if sendfile and isinstance(source, types.FileType):
            sfileno = source.fileno()
            size = os.fstat(sfileno).st_size
            outputfile.flush()
            sendfile(outputfile.fileno(), sfileno, 0, size)
        else:
            
            try:
                shutil.copyfileobj(source, outputfile, length = 32 * 1024)
            except socket.error:
                x = None
                print 'Socket error during copyfile:', x

        
        try:
            outputfile.flush()
        except socket.error:
            x = None
            print 'Socket error during copyfile flush:', x


    
    def address_string(self):
        (host, port) = self.client_address
        if not self.headers.get('x-forwarded-for'):
            pass
        realhost = host
        return str(realhost)

    
    def include(self, url, request, response):
        response.initiateRedirection(url, isInclude = True)
        handler = copy.copy(self)
        handler.doRedirect(self, url, request, response, True)

    
    def redirect(self, url, request, response):
        response.initiateRedirection(url)
        self.doRedirect(self, url, request, response, False)
        response.setRedirectionDone()

    
    def doRedirect(self, parentHandler, url, request, response, isInclude = False):
        if not (url[0] == '/'):
            
            try:
                result = urllib.urlopen(url)
                if result:
                    if not isInclude and not response.used():
                        for header, value in result.headers.items():
                            response.setHeader(header, value)
                        
                        response.writeHeader()
                    
                    response.forceFlush(self.wfile)
                    self.copyfile(result, self.wfile)
            except Exception:
                x = None
                response.sendError(404, 'not found: ' + str(x))
            except:
                None<EXCEPTION MATCH>Exception
            

        None<EXCEPTION MATCH>Exception
        self.path = url
        self.command = 'GET'
        result = self.send_head(request, response)
        if result:
            if not response.used():
                response.writeHeader()
            
            response.forceFlush(self.wfile)
            self.copyfile(result, self.wfile)
        



class ThreadingServer(SocketServer.ThreadingMixIn, BaseHTTPServer.HTTPServer):
    WEBAPPSDIR = 'webapps'
    INDEXPAGES = [
        'index.html',
        'index.htm',
        'index.y']
    
    def __init__(self, address, handler):
        BaseHTTPServer.HTTPServer.__init__(self, address, handler)
        self.mustShutdown = False
        self.serverURLprefix = ''
        self.requestCounter = 0
        self.debugRequests = False
        self.precompileYPages = True
        self.writePageSource = False

    
    def server_activate(self):
        self.virtualHosts = { }
        self.webRoots = { }
        self.vhostAliases = { }
        self.useVirtualHosts = True
        self.defaultVirtualHost = None
        import weakref
        self.allWebApps = weakref.WeakValueDictionary()
        BaseHTTPServer.HTTPServer.server_activate(self)
        self.setExternalPort(None)
        self._hostname_cache = { }
        self.startTime = time.time()

    
    def getHostName(self, ip):
        if self._hostname_cache.has_key(ip):
            return self._hostname_cache[ip]
        else:
            x = socket.getfqdn(ip)
            self._hostname_cache[ip] = x
            return x

    
    def readWebApps(self):
        
        try:
            exec 'from %s import ENABLED' % self.WEBAPPSDIR
            if ENABLED:
                exec 'from %s import virtualhosts' % self.WEBAPPSDIR
                exec 'from %s import webroots' % self.WEBAPPSDIR
                exec 'from %s import aliases' % self.WEBAPPSDIR
                exec 'from %s import defaultvhost' % self.WEBAPPSDIR
                if virtualhosts is None and webroots is None and defaultvhost is None or aliases is None:
                    raise ImportError('not everything is configured in the vhost config')
                
        except ImportError:
            print '\n\n\nError: no correct virtual host config found!'
            print 'Please read and edit the __init__.py file in the webapps directory.\n\n\n'
            raise SystemExit(1)

        if not ENABLED:
            print '\n\nNOTICE: VirtualHost configuration is NOT enabled.'
            print 'Defaulting to loading all available web apps to the current host.'
            if not self.server_address[0]:
                pass
            vhost = socket.gethostname()
            webapps = []
            if 'CVS' in webapps and os.access(os.path.join(self.WEBAPPSDIR, 'CVS', 'Entries'), os.R_OK):
                webapps.remove('CVS')
            
            virtualhosts = {
                vhost: webapps }
            webroots = { }
            if 'ROOT' in webapps:
                webroots = {
                    vhost: 'ROOT' }
                webapps.remove('ROOT')
            
            aliases = { }
            defaultvhost = vhost
            self.useVirtualHosts = False
        
        if defaultvhost not in virtualhosts:
            raise ValueError('invalid default virtualhost specified: ' + defaultvhost)
        
        for vhost in aliases.values():
            if vhost not in virtualhosts and vhost not in webroots:
                raise ValueError('invalid vhost specified in aliases: ' + vhost)
            
            if vhost in aliases:
                raise ValueError('alias cycle: ' + vhost)
                continue
        
        invalidAliases = []
        if invalidAliases:
            raise ValueError('aliases defined for true vhosts: ' + str(invalidAliases))
        
        for webroothost in webroots:
            if webroothost not in virtualhosts:
                raise ValueError('web root host is not a known virtualhost: ' + webroothost)
                continue
        
        self.vhostAliases = aliases
        self.allWebApps.clear()
        self.defaultVirtualHost = (defaultvhost, self.externalPort)
        webappsAlreadyPrecompiled = []
        self.virtualHosts.clear()
        for virtualhost, webapps in virtualhosts.iteritems():
            print "\n[ Processing virtual host '%s' ]" % virtualhost
            if type(webapps) not in (types.ListType, types.TupleType):
                raise ValueError("mapping value must be list of webapp names, but it isn't. vhost='%s'" % virtualhost)
            
            self.virtualHosts[virtualhost] = []
            webapps = list(webapps)
            for webname in webapps:
                print "Loading webapp '%s'" % webname
                if webapps.count(webname) > 1:
                    raise ValueError("Web application '%s' occurs more than once for vhost '%s'" % (webname, virtualhost))
                
                WA = self.readWebApp(webname, virtualhost, isRoot = False)
                if self.precompileYPages:
                    if webname not in webappsAlreadyPrecompiled:
                        WA.precompileYPages()
                        webappsAlreadyPrecompiled.append(webname)
                    else:
                        print '(already precompiled all Ypages)'
                
                print 'Got webapp:', WA
                self._registerWebApp(virtualhost, WA, isRoot = False)
            
        
        self.webRoots.clear()
        for virtualhost, webname in webroots.iteritems():
            if webname:
                print "\n[ Processing virtual host '%s' root webapp '%s' ]" % (virtualhost, webname)
                WA = self.readWebApp(webname, virtualhost, isRoot = True)
                if self.precompileYPages:
                    if webname not in webappsAlreadyPrecompiled:
                        WA.precompileYPages()
                        webappsAlreadyPrecompiled.append(webname)
                    else:
                        print '(already precompiled all Ypages)'
                
                print 'Got webapp:', WA
                self._registerWebApp(virtualhost, WA, isRoot = True)
                continue
        
        print '\nDefault virtual host: %s:%d' % self.defaultVirtualHost
        print len(self.allWebApps), 'webapps registered.\n'

    
    def _registerWebApp(self, virtualhost, WebApp, isRoot = False):
        if not isRoot:
            self.virtualHosts[virtualhost].append(WebApp)
        else:
            self.webRoots[virtualhost] = WebApp
        self.allWebApps[(virtualhost, WebApp.getURLprefix())] = WebApp

    
    def readWebApp(self, web, virtualHost, isRoot = False):
        abspath = os.path.abspath(os.path.join(self.WEBAPPSDIR, web))
        sys.path.append(abspath)
        if isRoot:
            url = '/'
        else:
            url = '/' + web + '/'
        port = self.externalPort
        WA = webapp.createWebApp(abspath, web, url, (virtualHost, port), self)
        if WA:
            print 'WEBAPP', web, ' (', len(WA.getSnakelets()), 'snakelets )'
            print ' name =', WA.getName()[1]
            print '  url =', WA.getURLprefix()
            return WA
        else:
            print '!!! webapp NOT installed'
            sys.path.remove(abspath)
            return None

    
    def getWebApp(self, url, virtualhost):
        if not url.startswith(self.serverURLprefix + '/'):
            return None
        
        if not (self.useVirtualHosts):
            virtualhost = self.defaultVirtualHost[0]
        else:
            virtualhost = self.vhostAliases.get(virtualhost, virtualhost)
        restrictedToWebApps = self.virtualHosts.get(virtualhost, [])
        restrictedToRootWebApp = self.webRoots.get(virtualhost, None)
        for webapp in restrictedToWebApps:
            if url.startswith(webapp.getURLprefix()):
                if webapp.isEnabled():
                    return webapp
                else:
                    break
            webapp.isEnabled()
        
        if restrictedToRootWebApp and restrictedToRootWebApp.isEnabled():
            return restrictedToRootWebApp
        else:
            return None

    
    def enableWebApp(self, vhost, urlprefix, enabled):
        self.allWebApps[(vhost, urlprefix)].setEnabled(enabled)

    
    def reloadWebApp(self, vhost, urlprefix):
        numapps = len(self.allWebApps)
        webapp = self.allWebApps[(vhost, urlprefix)]
        webappname = webapp.getName()[0]
        webappid = id(webapp)
        del webapp
        wasRoot = False
        if vhost in self.webRoots:
            wasRoot = self.webRoots[vhost].getName()[0] == webappname
        
        print "UNLOADING WEBAPP '%s' [%s] id=%08x" % (webappname, vhost, webappid)
        if self.unloadWebApp(vhost, urlprefix):
            if len(self.allWebApps) != numapps - 1:
                print "**** WEBAPP '%s' [%s] DIDN'T UNLOAD FULLY ****" % (webappname, vhost)
            
            WA = self.readWebApp(webappname, vhost, isRoot = wasRoot)
            self._registerWebApp(vhost, WA, isRoot = wasRoot)
            print "RELOADED WEBAPP '%s' [%s] id=%08x" % (webappname, vhost, id(WA))
            return True
        else:
            return False

    
    def clearWebAppCache(self, vhost, urlprefix):
        self.allWebApps[(vhost, urlprefix)].clearCache()

    
    def unloadWebApp(self, vhost, web):
        webapp = self.allWebApps[(vhost, web)]
        name = os.path.split(webapp.getFileSystemPath())[1]
        modulename = 'webapps.' + name
        instances = []
        if len(instances) > 1:
            return False
        
        del instances
        for n in sys.modules.keys()[:]:
            if n.startswith(modulename) and type(sys.modules[n]) is types.ModuleType:
                del sys.modules[n]
                continue
        
        if webapp in self.virtualHosts[vhost]:
            self.virtualHosts[vhost].remove(webapp)
        
        if vhost in self.webRoots and self.webRoots[vhost] is webapp:
            del self.webRoots[vhost]
        
        return True

    
    def setServerURLprefix(self, serverURLprefix):
        self.serverURLprefix = serverURLprefix

    
    def addIndexPage(self, indexpage):
        self.INDEXPAGES.append(indexpage)

    
    def getUpTime(self):
        secs = int(time.time() - self.startTime)
        days = secs / (24 * 3600)
        secs -= days * 24 * 3600
        hours = secs / 3600
        secs -= hours * 3600
        mins = secs / 60
        secs -= mins * 60
        return (days, hours, mins, secs)

    
    def getRequestCount(self):
        return self.requestCounter

    
    def shutdown(self):
        self.mustShutdown = True

    
    def serve_forever(self):
        self.mustShutdown = False
        while not (self.mustShutdown):
            (ins, outs, excs) = select.select([
                self], [], [
                self], 10)
            if self in ins:
                self.handle_request()
            
            self.reapSessions()
        print 'Shutting down gracefully.'

    
    def reapSessions(self):
        for webapp in self.allWebApps.values():
            webapp.scanSessionTimeouts()
        

    
    def setDebugRequests(self, status):
        self.debugRequests = status

    
    def setExternalPort(self, externalPort):
        if not externalPort:
            pass
        self.externalPort = self.server_port

    
    def setPrecompileYPages(self, precompileYPages):
        self.precompileYPages = precompileYPages

    
    def setWritePageSource(self, writePageSource):
        self.writePageSource = writePageSource



def createHTTPD(HTTPD_PORT, externalPort, bindname, serverURLprefix, debugRequests, precompileYPages, writePageSource):
    print 'Creating server on "%s"' % bindname
    httpd = ThreadingServer((bindname, HTTPD_PORT), MyRequestHandler)
    if serverURLprefix:
        if not serverURLprefix.startswith('/'):
            serverURLprefix = '/' + serverURLprefix
        
        if serverURLprefix.endswith('/'):
            serverURLprefix = serverURLprefix[:-1]
        
    
    httpd.setServerURLprefix(serverURLprefix)
    httpd.setDebugRequests(debugRequests)
    httpd.setExternalPort(externalPort)
    httpd.setPrecompileYPages(precompileYPages)
    httpd.setWritePageSource(writePageSource)
    httpd.readWebApps()
    if serverURLprefix:
        print 'Server URL prefix:', serverURLprefix
    
    print SNAKELETS_VERSION, 'serving HTTP on port', HTTPD_PORT
    return httpd


def main(HTTPD_PORT = 80, externalPort = None, bindname = None, serverURLprefix = '', debugRequests = False, precompileYPages = True, writePageSource = False):
    if bindname is None:
        bindname = socket.gethostname()
    
    
    try:
        httpd = createHTTPD(HTTPD_PORT, externalPort, bindname, serverURLprefix, debugRequests, precompileYPages, writePageSource)
        print 'Starting at', time.asctime(time.gmtime()), 'GMT'
        sys.stdout.flush()
        httpd.serve_forever()
        print 'Exiting at', time.asctime(time.gmtime()), 'GMT'
        sys.stdout.flush()
        raise SystemExit
    except webapp.WebAppInitialisationError:
        print "Server couldn't start due to errors."


if __name__ == '__main__':
    main()

