# Source Generated with Decompyle++
# File: in.pyc (Python 2.3)

import urllib
import cgi
import types
import httpauth
from util import ContextContainer
import weakref

class Snakelet:
    SESSION_NOT_NEEDED = 0
    SESSION_WANTED = 1
    SESSION_REQUIRED = 2
    SESSION_LOGIN_REQUIRED = 3
    
    def __init__(self, url, webappref):
        if type(webappref) != weakref.ReferenceType:
            raise TypeError('webapp arg for snakelet must be a weakref')
        
        self._webappref = webappref
        self.urlpattern = urllib.basejoin(self._webappref().getURLprefix(), url)
        self.snakeletctx = ContextContainer()
        self.content_type = 'text/html'
        self.errorpage = None
        self.init()

    
    def init(self):
        pass

    
    def getDescription(self):
        return '-'

    
    def getAuthMethod(self):
        return None

    
    def getBasicAuthRealm(self):
        return self.urlpattern + ' (' + self.getDescription() + ')'

    
    def getContext(self):
        return self.snakeletctx

    
    def getAppContext(self):
        return self.getWebApp().getContext()

    
    def getFullURL(self, request):
        (vhost, port) = self.getWebApp().getVirtualHost()
        base = 'http://' + vhost
        if port and port != 80:
            base += ':%d' % port
        
        return (base + '///' + request.getRequestURLplain()).replace('/////', '/').replace('////', '/')

    
    def getURL(self):
        return self.urlpattern

    
    def getWebApp(self):
        return self._webappref()

    
    def requiresSession(self):
        return self.SESSION_WANTED

    
    def getSessionSigninPage(self):
        return None

    
    def allowCaching(self):
        return False

    
    def getMTime(self):
        return self.getWebApp().startuptime

    
    def redirect(self, URL, request, response):
        URL = urllib.basejoin(self.urlpattern, URL)
        if response.header_written or response.redirection_performed:
            del request
            del response
            raise RuntimeError('can not redirect twice or when getOutput() has been called')
        
        request.server.redirect(URL, request, response)

    
    def include(self, URL, request, response):
        URL = urllib.basejoin(self.urlpattern, URL)
        return request.server.include(URL, request, response)

    
    def getErrorPage(self):
        return self.errorpage

    
    def setErrorPage(self, page):
        self.errorpage = page

    
    def HTTPauthenticate(self, *vargs, **kwargs):
        return httpauth.HTTPauthenticate(*vargs, **kwargs)

    
    def escape(self, string):
        if string:
            if type(string) in types.StringTypes:
                return cgi.escape(string, 1)
            else:
                raise TypeError('must be string argument')
        else:
            return ''

    
    def urlescape(self, url):
        return urllib.quote_plus(url)


