# Source Generated with Decompyle++
# File: in.pyc (Python 2.3)

import os
import urllib
import cStringIO
import cgi
import time
import md5
import sys
import random
import types
import weakref
import codecs
import binascii
import fnmatch
import snakelet
import httpauth
from threading import Lock
from YpageEngine import YpageEngine
from ypage.compiler import CompilerError
from mycookie import SESSION_COOKIE_NAME
import request_response
import websession

class NotHandled(Exception):
    pass


class TooManySessions(Exception):
    pass


class WebAppInitialisationError(Exception):
    pass


class WebAppContext:
    
    def __init__(self, webapp):
        self.AbsPath = unicode(webapp.getFileSystemPath())
        self.Name = unicode(webapp.getName())
        self.UrlPrefix = unicode(webapp.getURLprefix())



def DefaultDirListAllower(path):
    return False


def DefaultDocumentAllower(path):
    return os.path.splitext(path)[1].lower() not in ('.py', '.pyc')


class WebAppConfigError(Exception):
    pass


def createWebApp(abspath, webapp_path, urlprefix, virtualHost, server):
    exec 'import webapps.' + webapp_path + ' as WA'
    WA.configItems = getattr(WA, 'configItems', { })
    WA.dirListAllower = getattr(WA, 'dirListAllower', None)
    WA.documentAllower = getattr(WA, 'documentAllower', None)
    WA.defaultOutputEncoding = getattr(WA, 'defaultOutputEncoding', None)
    WA.defaultPageTemplate = getattr(WA, 'defaultPageTemplate', None)
    WA.compileAllPages = server.precompileYPages
    WA.writePageSource = server.writePageSource
    WA.startloc = getattr(WA, 'start', '')
    WA.sessionTimeoutSecs = getattr(WA, 'sessionTimeoutSecs', 600)
    WA.initFunc = getattr(WA, 'init', None)
    WA.absFSpath = abspath
    WA.shortname = webapp_path
    WA.urlprefix = server.serverURLprefix + urlprefix
    WA.virtualHost = virtualHost
    WA.server = server
    
    try:
        webapp = WebApp(WA)
        webapp.setDefaultOutputEncoding(WA.defaultOutputEncoding)
        webapp.setDefaultPageTemplate(WA.defaultPageTemplate)
    except (WebAppConfigError, StandardError):
        x = None
        print '!!! problem during webapp load:', x
        print '!!! webapp=', urlprefix
        import traceback
        traceback.print_exc()
        return None

    return webapp


class WebApp:
    
    def __init__(self, WAConfig):
        self.configitems = WAConfig.configItems
        self.absFSpath = WAConfig.absFSpath
        self.docrootFSPath = os.path.normpath(os.path.join(self.absFSpath, WAConfig.docroot))
        self.name = (WAConfig.shortname, WAConfig.name)
        self.urlprefix = unicode(WAConfig.urlprefix)
        self.sessionTimeoutSecs = WAConfig.sessionTimeoutSecs
        self.server = WAConfig.server
        if not WAConfig.dirListAllower:
            pass
        self.dirListAllower = DefaultDirListAllower
        if not WAConfig.documentAllower:
            pass
        self.documentAllower = DefaultDocumentAllower
        self._startloc_relative = WAConfig.startloc
        self.startloc = self.urlprefix + self._startloc_relative
        self.virtualHost = WAConfig.virtualHost
        self.enabled = True
        self.authMethod = None
        self.startuptime = time.time()
        self.defaultOutputEncoding = None
        self.defaultPageTemplate = None
        self.sessionCreatedCallback = None
        self.context = WebAppContext(self)
        self.snakelets = { }
        for snk, snakeletClass in WAConfig.snakelets.items():
            self.snakelets[snk] = snakeletClass(snk, weakref.ref(self))
        
        self.sessions = { }
        self.lock = Lock()
        self.pageEngine = YpageEngine(WAConfig.shortname, self.virtualHost[0], WAConfig.writePageSource)
        if WAConfig.initFunc:
            WAConfig.initFunc(self)
        

    
    def __str__(self):
        return "[WebApp '" + self.getName()[1] + "' urlprefix=" + self.getURLprefix() + ']'

    
    def getFileSystemPath(self):
        return self.absFSpath

    
    def getDocRootPath(self):
        return self.docrootFSPath

    
    def getName(self):
        return self.name

    
    def isEnabled(self):
        return self.enabled

    
    def setEnabled(self, enabled):
        self.enabled = enabled

    
    def setDefaultOutputEncoding(self, encoding):
        self.defaultOutputEncoding = encoding

    
    def getDefaultOutputEncoding(self):
        return self.defaultOutputEncoding

    
    def setDefaultPageTemplate(self, template):
        self.defaultPageTemplate = template

    
    def getDefaultPageTemplate(self):
        return self.defaultPageTemplate

    
    def setSessionCreatedCallback(self, callback):
        self.sessionCreatedCallback = callback

    
    def getVirtualHost(self):
        return self.virtualHost

    
    def getContext(self):
        return self.context

    
    def getURLprefix(self):
        return self.urlprefix

    
    def getConfigItems(self):
        return self.configitems

    
    def getConfigItem(self, item):
        return self.configitems[item]

    
    def getSnakelets(self):
        return self.snakelets

    
    def getStartLocation(self):
        return self.startloc

    
    def _getPath(self, handlerpath):
        return handlerpath[len(self.getURLprefix()):]

    
    def getFullPath(self, path):
        return os.path.join(self.getDocRootPath(), urllib.url2pathname(path))

    
    def do_HEAD(self, handler):
        path = self._getPath(handler.path)
        result = self.is_snakelet(path)
        if result:
            handler.send_response(200, 'OK')
            self.sendPageHeaders(self.snakelets[result[0]], handler)
            handler.end_headers()
            return None
        
        result = self.is_Ypage(path)
        if result:
            self.run_Ypage_GET(handler, result[0], result[1], None, None, True)
            handler.end_headers()
            return None
        
        raise NotHandled()

    
    def do_GET(self, handler, passtroughRequest, passtroughResponse):
        path = self._getPath(handler.path)
        result = self.is_snakelet(path)
        if result:
            self.run_snakelet(handler, result[0], result[1], passtroughRequest, passtroughResponse)
            return None
        
        result = self.is_Ypage(path)
        if result:
            return self.run_Ypage_GET(handler, result[0], result[1], passtroughRequest, passtroughResponse)
        
        raise NotHandled()

    
    def do_POST(self, handler):
        path = self._getPath(handler.path)
        result = self.is_snakelet(path)
        if result:
            return self.run_snakelet(handler, result[0], result[1])
        
        result = self.is_Ypage(path)
        if result:
            return self.run_Ypage_POST(handler, result[0], result[1])
        else:
            handler.send_error(501, 'Can only POST to scripts (not static pages), or your POST url is invalid.')
            return None

    HTTP_NOCACHE_HEADERS = {
        'Pragma': 'No-cache',
        'Cache-Control': 'private, max-age=0',
        'Expires': '0' }
    
    def addPageHeaders(self, snakelet, response):
        if snakelet.allowCaching():
            (etag, lmod) = self.create_ETag_LMod_headers(snakelet.getMTime(), 0, id(snakelet))
            response.setHeader('ETag', etag)
            response.setHeader('Last-Modified', lmod)
        else:
            for header, value in self.HTTP_NOCACHE_HEADERS.iteritems():
                response.setHeader(header, value)
            

    
    def sendPageHeaders(self, snakelet, handler):
        if snakelet.allowCaching():
            (etag, lmod) = self.create_ETag_LMod_headers(snakelet.getMTime(), 0, id(snakelet))
            handler.send_header('ETag', etag)
            handler.send_header('Last-Modified', lmod)
        else:
            for header, value in self.HTTP_NOCACHE_HEADERS.iteritems():
                handler.send_header(header, value)
            

    
    def is_snakelet(self, path):
        real_path = path.split('?')[0]
        for snake in self.snakelets:
            if '*' in snake and '?' in snake and '[' in snake and ']' in snake:
                if fnmatch.fnmatchcase(real_path, snake):
                    args = path[len(real_path):]
                    if not args or args[0] in ('?', '/'):
                        return (snake, args)
                    
                
            fnmatch.fnmatchcase(real_path, snake)
            if path.startswith(snake):
                args = path[len(snake):]
                if not args or args[0] in ('?', '/'):
                    return (snake, args)
                
            args[0] in ('?', '/')
        
        return None

    
    def is_Ypage(self, path):
        (path, query) = urllib.splitquery(path)
        if query:
            query = '?' + query
        else:
            query = ''
        _suffix = '.y'
        if path.endswith(_suffix):
            if not query:
                pass
            return (path, '')
        else:
            path = path.split(_suffix + '/', 1)
            if len(path) > 1:
                query = '/' + path[1] + query
                return (path[0] + _suffix, query)
            
        return None

    
    def allowDirListing(self, path):
        return self.dirListAllower(self._getPath(path))

    
    def allowDocument(self, path):
        return self.documentAllower(self._getPath(path))

    
    def run_snakelet(self, handler, context, query, passtroughRequest = None, passtroughResponse = None):
        i = query.rfind('?')
        if i >= 0:
            (pathinfo, query) = (query[:i], query[i + 1:])
        else:
            (pathinfo, query) = (query, '')
        snake = self.snakelets[context]
        req = None
        resp = None
        
        try:
            if passtroughRequest:
                req = passtroughRequest
            else:
                req = request_response.Request(self, pathinfo, query, handler, handler.rfile)
            if not passtroughResponse:
                pass
            resp = request_response.Response(handler, handler.wfile)
            if snake.requiresSession() != snakelet.Snakelet.SESSION_NOT_NEEDED:
                
                try:
                    session = self.addSessionCookie(req, resp)
                except TooManySessions:
                    resp.sendError(503, 'too many sessions')
                    return None
                except:
                    None<EXCEPTION MATCH>TooManySessions
                

            None<EXCEPTION MATCH>TooManySessions
            if snake.requiresSession() == snakelet.Snakelet.SESSION_REQUIRED and session.isNew():
                resp.sendError(403, 'Your session must be synchronised (not new) to access this page. Are cookies switched off?')
                return None
            
            if snake.requiresSession() == snakelet.Snakelet.SESSION_LOGIN_REQUIRED and not req.getSession().getLoggedInUser():
                if snake.getSessionSigninPage():
                    req.setParameter('RETURNPAGE', req.getBaseURL() + req.getRequestURL())
                    snake.redirect(snake.getSessionSigninPage(), req, resp)
                else:
                    resp.sendError(403, 'You must be logged in to access this page.')
                return None
            
            self.addPageHeaders(snake, resp)
            resp.setEncoding(self.getDefaultOutputEncoding())
            if snake.getAuthMethod():
                if snake.getAuthMethod() == 'basic':
                    
                    try:
                        (user, password) = httpauth.HTTPauthenticate(req, resp, snake.basicAuthValidator, authRealm = snake.getBasicAuthRealm())
                        req.setAuthenticatedUserPW(user, password)
                        snake.serve(req, resp)
                    except httpauth.AuthError:
                        x = None
                        print 'AUTH ERROR', x
                        return None
                    except:
                        None<EXCEPTION MATCH>httpauth.AuthError
                    

                None<EXCEPTION MATCH>httpauth.AuthError
                del req
                del resp
                del snake
                raise httpauth.AuthError("only supports 'basic' authentication")
            else:
                snake.serve(req, resp)
            if not resp.used():
                resp.sendError(404, 'snakelet had no output')
        except Exception:
            x = None
            self.reportSnakeletException(snake, x, handler, handler.wfile, req, resp, snake.getErrorPage())
            return None


    
    def reportSnakeletException(self, snakelet, exc, handler, out, request, response, errorpage = None):
        (typ, value, tb) = sys.exc_info()
        sys.exc_clear()
        if type(typ) == types.StringType:
            name = typ
        else:
            name = typ.__name__
        if handler:
            if snakelet:
                handler.log_error("SNAKELET '" + snakelet.getURL() + "' threw exception: " + name + ': ' + str(value))
            else:
                handler.log_error('PAGE threw exception: ' + name + ': ' + str(value))
            response.setResponse(500, 'Internal server error')
        
        if errorpage and request:
            
            try:
                request.setParameter('Exception', exc)
                request.setParameter('Exception_page', snakelet.getURL())
                request.setParameter('Exception_type', typ)
                request.setParameter('Exception_value', value)
                request.setParameter('Exception_tb', tb)
                snakelet.redirect(errorpage, request, response)
                request.setParameter('Exception', None)
                request.setParameter('Exception_tb', None)
                return None
            except Exception:
                x = None
                del tb
                return self.reportSnakeletException(snakelet, x, handler, out, request, response, None)
            except:
                None<EXCEPTION MATCH>Exception
            

        None<EXCEPTION MATCH>Exception
        if not response.used():
            response.writeHeader()
        
        import traceback
        out.write('<html><head><title>Server error</title></head><body><hr><h2>Exception in server</h2>\n')
        if snakelet:
            out.write('<h3>Page &quot;' + snakelet.getURL() + '&quot; caused an error: ' + str(value) + '</h3>\n')
        else:
            out.write('<h3>Page caused an error: ' + str(value) + '</h3>\n')
        if hasattr(exc, 'Snakelets_extrainfo'):
            out.write('<h3>Extra information:</h3>' + exc.Snakelets_extrainfo)
        
        out.write('<H3>Traceback (innermost last):</H3>\n')
        lst = traceback.format_tb(tb) + traceback.format_exception_only(typ, value)
        out.write('<PRE>%s<strong>%s</strong></PRE></body></html>\n' % (cgi.escape(''.join(lst[:-1]), 1), cgi.escape(lst[-1], 1)))
        return None

    
    def run_Ypage_POST(self, handler, page, query):
        result = self.run_Ypage_GET(handler, page, query)
        if result:
            handler.copyfile(result, handler.wfile)
        

    
    def run_Ypage_GET(self, handler, path, query, passtroughRequest = None, passtroughResponse = None, HEADrequestOnly = False):
        fullpath = self.getFullPath(path)
        i = query.rfind('?')
        if i >= 0:
            (pathinfo, query) = (query[:i], query[i + 1:])
        else:
            (pathinfo, query) = (query, '')
        errorpage = None
        page = None
        req = None
        resp = None
        
        try:
            if not os.access(fullpath, os.R_OK):
                print '404-->no read access:', fullpath
                handler.send_error(404)
                return None
            
            if passtroughRequest:
                req = passtroughRequest
            else:
                req = request_response.Request(self, pathinfo, query, handler, handler.rfile)
            if not passtroughResponse:
                pass
            resp = request_response.Response(handler, handler.wfile)
            outputEncoding = contentType = contentDisposition = None
            
            try:
                page = self.pageEngine.loadPage(fullpath, path, self)
                if HEADrequestOnly:
                    handler.send_response(200, 'OK')
                    self.sendPageHeaders(page, handler)
                    return None
                
                
                try:
                    self.pageEngine.addPageVars(page, self, req, resp)
                except TooManySessions:
                    return resp.sendError(503, 'too many sessions for your IP address')

                if page.requiresSession() == snakelet.Snakelet.SESSION_REQUIRED:
                    session = req.getSession()
                    if not session or session.isNew():
                        resp.sendError(403, 'Your session must be synchronised (not new) to access this page. Are cookies switched off?')
                        return None
                    
                
                if page.requiresSession() == snakelet.Snakelet.SESSION_LOGIN_REQUIRED:
                    if not hasattr(page, 'User') or not (page.User):
                        if page.getSessionSigninPage():
                            req.setParameter('RETURNPAGE', req.getBaseURL() + req.getRequestURL())
                            page.redirect(page.getSessionSigninPage(), req, resp)
                        else:
                            resp.sendError(403, 'You must be logged in to access this page.')
                        return None
                    
                
                errorpage = page.getErrorPage()
                (contentType, contentDisposition) = (output, outputSize, outputEncoding)
            except CompilerError:
                cx = None
                if HEADrequestOnly:
                    resp.sendError(500)
                    return None
                
                output = cStringIO.StringIO()
                print 'YPAGE-COMPILER ERROR!!!!!!', cx
                output.write('<html><head><title>Server error</title></head><body><hr><h2>Exception in server</h2>\n')
                output.write('<h3>Error compiling page &quot;' + path + '&quot;: ' + str(cx) + '</h3>')
                if hasattr(cx, 'Snakelets_extrainfo'):
                    out.write('<h3>Extra information:</h3>' + cx.Snakelets_extrainfo)
                
                output.write('<h4>More info can be found in the server output or log.</h4></body></html>\n')
                outputSize = len(output.getvalue())
                outputEncoding = contentType = contentDisposition = None
                output.seek(0)

            if outputEncoding:
                resp.setEncoding(outputEncoding)
            
            if contentType:
                resp.setContentType(contentType)
            
            if contentDisposition:
                resp.setContentDisposition(contentDisposition)
            
            resp.setContentLength(outputSize)
            if not resp.used():
                resp.writeHeader()
            
            return output
        except IOError:
            x = None
            print '404-->generic io error', x, ' path=', path
            handler.send_error(404)
            return None
        except Exception:
            x = None
            self.reportSnakeletException(page, x, handler, handler.wfile, req, resp, errorpage)
            return None


    
    def clearCache(self):
        self.pageEngine.clearCache()

    
    def getPageEngine(self):
        return self.pageEngine

    
    def addSessionCookie(self, request, response):
        self.lock.acquire()
        
        try:
            if request.session:
                return request.session
            
            
            try:
                sessionIDs = request.getCookies()[SESSION_COOKIE_NAME]
                for sessionID in sessionIDs:
                    
                    try:
                        session = self.sessions[sessionID]
                        request.setSession(session)
                        session.touch()
                        session.setRequestData(request, response)
                        return session
                    continue
                    except KeyError:
                        continue
                    

            except KeyError:
                pass

            print '--- No session cookie or invalid id, creating new'
            remoteAddr = str(request.getRealRemoteAddr())
            if len([]) > 50:
                print 'Too many sessions for remote address', remoteAddr, '; refused'
                del request
                del response
                raise TooManySessions
            
            sessionID = md5.md5(remoteAddr + str(time.time()) + str(random.random())).hexdigest()
            session = websession.Session(sessionID, self.sessionTimeoutSecs, remoteAddr, weakref.ref(self))
            response.setCookie(SESSION_COOKIE_NAME, sessionID, path = self.getURLprefix())
            self.sessions[sessionID] = session
            request.setSession(session)
            session.setRequestData(request, response)
            print '--- new sessionID=', sessionID
            if self.sessionCreatedCallback:
                self.sessionCreatedCallback(session, self, request)
            
            return session
        finally:
            self.lock.release()


    
    def _deleteSession(self, session, response = None):
        self.lock.acquire()
        
        try:
            del self.sessions[session.getID()]
            if response:
                response.delCookie(SESSION_COOKIE_NAME, path = self.getURLprefix()[:-1])
            
            print 'SERVER: deleted session ', session.getID()
        finally:
            self.lock.release()


    
    def _getActiveSessions(self):
        return self.sessions

    
    def scanSessionTimeouts(self):
        for session in self.sessions.values()[:]:
            session.destroyIfOverAged()
        

    
    def setAuthentication(self, authenticationMethod, basic_authentication_checker):
        self.authMethod = authenticationMethod
        self.basic_authentication_checker = basic_authentication_checker
        if self.authMethod and self.authMethod != 'basic':
            raise WebAppConfigError("only supports 'basic' authentication method")
        

    
    def precompileYPages(self):
        print 'Precompiling all Ypages...'
        errorlist = []
        striplen = len(os.path.join(self.getDocRootPath(), 'abc')) - 3
        for dirname, dirs, files in os.walk(self.getDocRootPath()):
            if 'CVS' in dirs:
                dirs.remove('CVS')
            
            for file in files:
                if file.endswith('.y'):
                    entrypath = os.path.join(dirname[striplen:], file)
                    fullpath = self.getFullPath(entrypath)
                    
                    try:
                        self.pageEngine.loadPage(fullpath, entrypath, self)
                    except CompilerError:
                        x = None
                        print '\nERROR COMPILING YPAGE', file
                        errorlist.append((entrypath, str(x)))
                    except:
                        None<EXCEPTION MATCH>CompilerError
                    

                None<EXCEPTION MATCH>CompilerError
            
        
        if errorlist:
            print '\n' + '-' * 40 + '\nTHERE WERE', len(errorlist), "ERRORS IN THE YPAGES OF WEBAPP '%s':\n" % self.getName()[0]
            for url, error in errorlist:
                print '%s  :  %s' % (url, error)
            
            print 
            raise WebAppInitialisationError
        

    
    def create_ETag_LMod_headers(self, timestamp, size, locationid):
        now = time.time()
        if timestamp > now:
            timestamp = now
        
        etag = ''
        etag = '"%s"' % binascii.b2a_base64(etag).strip()
        (year, month, day, hh, mm, ss, wd, y, z) = time.gmtime(timestamp)
        datestr = '%s, %02d %3s %4d %02d:%02d:%02d GMT' % (self.weekdayname[wd], day, self.monthname[month], year, hh, mm, ss)
        return (etag, datestr)

    weekdayname = [
        'Mon',
        'Tue',
        'Wed',
        'Thu',
        'Fri',
        'Sat',
        'Sun']
    monthname = [
        None,
        'Jan',
        'Feb',
        'Mar',
        'Apr',
        'May',
        'Jun',
        'Jul',
        'Aug',
        'Sep',
        'Oct',
        'Nov',
        'Dec']

